'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _constants = require('../constants');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var BaseRouterComponent = function (_PureComponent) {
    _inherits(BaseRouterComponent, _PureComponent);

    function BaseRouterComponent(props, context) {
        _classCallCheck(this, BaseRouterComponent);

        var _this = _possibleConstructorReturn(this, (BaseRouterComponent.__proto__ || Object.getPrototypeOf(BaseRouterComponent)).call(this, props, context));

        var store = context.store,
            router = context.router;

        _this.store = store;
        _this.router = router;

        _this.handleStoreChange = _this.handleStoreChange.bind(_this);

        _this.unsubscribe = store && store.subscribe(_this.handleStoreChange);
        return _this;
    }

    _createClass(BaseRouterComponent, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
            return this.handleStoreChange();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {

            if (this.isSubscribed) {
                this.unsubscribe();
                delete this.unsubscribe;
            }
        }
    }, {
        key: 'handleStoreChange',
        value: function handleStoreChange() {
            // eslint-disable-line class-methods-use-this
            throw new Error('this.handleStoreChange() should be implemented');
        }
    }, {
        key: 'getStatefromStore',
        value: function getStatefromStore() {
            var _router = this.router,
                _router$slice = _router.slice,
                slice = _router$slice === undefined ? _constants.DEFAULT_SLICE : _router$slice,
                immutable = _router.immutable;

            var state = this.store.getState();
            return immutable ? state.get(slice) : state[slice];
        }
    }, {
        key: 'isSubscribed',
        get: function get() {

            return typeof this.unsubscribe === 'function';
        }
    }]);

    return BaseRouterComponent;
}(_react.PureComponent);

exports.default = BaseRouterComponent;