'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Base = require('./Base');

var _Base2 = _interopRequireDefault(_Base);

var _constants = require('../constants');

var _actions = require('../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Fragment = function (_BaseRouterComponent) {
    _inherits(Fragment, _BaseRouterComponent);

    function Fragment(props, context) {
        _classCallCheck(this, Fragment);

        var _this = _possibleConstructorReturn(this, (Fragment.__proto__ || Object.getPrototypeOf(Fragment)).call(this, props, context));

        var id = _this.props.id;

        _this.current = _this.router.current ? _this.router.current + _constants.ID_DELIM + id : id;

        _this.state = {
            visible: false
        };
        return _this;
    }

    _createClass(Fragment, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
            var redirect = this.props.redirect;

            var newRedirect = newProps.redirect;

            if (!redirect && newRedirect || newRedirect && redirect && newRedirect.id !== redirect.id || typeof newRedirect === 'string' && redirect !== newRedirect) {
                this.handleStoreChange(newProps);
            }
        }
    }, {
        key: 'getChildContext',
        value: function getChildContext() {
            var router = this.context.router;


            return { router: _extends({}, router, { current: this.current }) };
        }
    }, {
        key: 'handleStoreChange',
        value: function handleStoreChange(newProps) {

            if (!this.isSubscribed) return;

            var _router = this.router,
                immutable = _router.immutable,
                parseRoute = _router.parseRoute;

            var _ref = newProps || this.props,
                redirect = _ref.redirect;

            var current = this.current;
            var storeState = this.getStatefromStore();
            var routerStore = immutable ? storeState.toJS() : storeState;

            if (routerStore) {
                var idPath = routerStore.route.idPath;
                var params = routerStore.route.params;
                var query = routerStore.query;
                var hash = routerStore.hash;
                var routePath = idPath + _constants.ID_DELIM;
                var fragmentPath = current + _constants.ID_DELIM;
                var match = routePath.indexOf(fragmentPath);
                var matchExact = routePath === fragmentPath;

                if (matchExact && redirect) {
                    var redirectRoute = (typeof redirect === 'undefined' ? 'undefined' : _typeof(redirect)) === 'object' && redirect.id ? parseRoute(_extends({ params: params, query: query, hash: hash }, redirect)) : redirect;

                    return this.store.dispatch((0, _actions.replace)(redirectRoute));
                }

                if (match === 0 && !this.state.visible) {
                    return this.setState({
                        matchExact: matchExact,
                        visible: true
                    });
                }
                if (match !== 0 && this.state.visible) {
                    return this.setState({
                        matchExact: matchExact,
                        visible: false
                    });
                }
            }
        }
    }, {
        key: 'render',
        value: function render() {
            var _state = this.state,
                visible = _state.visible,
                matchExact = _state.matchExact,
                redirect = _state.redirect;
            var _props = this.props,
                children = _props.children,
                ChildComponent = _props.component;


            if (!visible || matchExact && redirect) return null; // eslint-disable-line
            if (ChildComponent) return children ? _react2.default.createElement(
                ChildComponent,
                null,
                children
            ) : _react2.default.createElement(ChildComponent, null); // eslint-disable-line
            if (children) return _react2.default.createElement(
                'div',
                null,
                children
            ); // eslint-disable-line
        }
    }]);

    return Fragment;
}(_Base2.default);

Fragment.contextTypes = {
    router: _propTypes2.default.object,
    store: _propTypes2.default.object
};

Fragment.childContextTypes = {
    router: _propTypes2.default.shape({
        slice: _propTypes2.default.string,
        immutable: _propTypes2.default.bool,
        routes: _propTypes2.default.array
    }).isRequired,
    store: _propTypes2.default.object
};

if (_constants.__DEV__) {
    Fragment.propTypes = {
        id: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
        children: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.string, _propTypes2.default.array]),
        component: _propTypes2.default.func,
        redirect: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.string])
    };
}

exports.default = Fragment;