'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Base = require('./Base');

var _Base2 = _interopRequireDefault(_Base);

var _url = require('url');

var _queryString = require('query-string');

var _queryString2 = _interopRequireDefault(_queryString);

var _actions = require('../actions');

var actions = _interopRequireWildcard(_actions);

var _constants = require('../constants');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var compareQueryItems = function compareQueryItems(linkQueryItem, routeQueryItem) {

    linkQueryItem = [].concat(linkQueryItem);
    routeQueryItem = [].concat(routeQueryItem);

    return linkQueryItem.reduce(function (result, linkQuerySubItem) {
        result = result && routeQueryItem.includes(linkQuerySubItem.toString());
        return result;
    }, true);
};

function filterProps(props) {

    var propsCopy = Object.assign({}, props);

    var managedProps = ['to', 'activeClass', 'method', 'activeMatch'];

    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
        for (var _iterator = managedProps[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var prop = _step.value;

            delete propsCopy[prop];
        }
    } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
    } finally {
        try {
            if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
            }
        } finally {
            if (_didIteratorError) {
                throw _iteratorError;
            }
        }
    }

    return propsCopy;
}

var Link = function (_BaseRouterComponent) {
    _inherits(Link, _BaseRouterComponent);

    function Link(props, context) {
        _classCallCheck(this, Link);

        var _this = _possibleConstructorReturn(this, (Link.__proto__ || Object.getPrototypeOf(Link)).call(this, props, context));

        _this.handleClick = _this.handleClick.bind(_this);

        _this.href = _this.getHref(props);
        _this.state = {
            isActive: false
        };
        return _this;
    }

    _createClass(Link, [{
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {

            if (this.props.to !== newProps.to) {
                this.href = this.getHref(newProps);
            }
        }
    }, {
        key: 'initiateLocationChange',
        value: function initiateLocationChange(e) {
            var target = this.props.target;


            if (!target && !e.altKey && !e.metaKey && !e.ctrlKey && !this.href.protocol && (e.nativeEvent && e.nativeEvent.which) !== 2) {
                e.preventDefault();
                this.locationChange(this.href);
            }
        }
    }, {
        key: 'handleClick',
        value: function handleClick(e) {
            var _this2 = this;

            var onClick = this.props.onClick;


            if (typeof onClick === 'function') {
                var onClickResult = onClick(e);

                if ((typeof onClickResult === 'undefined' ? 'undefined' : _typeof(onClickResult)) === 'object' && typeof onClickResult.then === 'function') {
                    e.persist();

                    return onClickResult.then(function () {
                        if (!e.defaultPrevented) {
                            _this2.initiateLocationChange(e);
                        }
                    });
                }
            }

            if (!e.defaultPrevented) {
                return this.initiateLocationChange(e);
            }
        }
    }, {
        key: 'getHref',
        value: function getHref(props) {
            var to = props.to;


            if ((typeof to === 'undefined' ? 'undefined' : _typeof(to)) === 'object' && to.id) {
                to = this.router.parseRoute(to);
            }

            if (typeof to === 'string') {
                to = (0, _url.parse)(to);
                to.query = _queryString2.default.parse(to.query);
            }

            to.hash = typeof to.hash === 'string' && to.hash[0] !== '#' ? '#' + to.hash : to.hash;

            return to || false;
        }
    }, {
        key: 'handleStoreChange',
        value: function handleStoreChange() {

            if (!this.isSubscribed) return;

            var _props = this.props,
                activeClass = _props.activeClass,
                activeMatch = _props.activeMatch;
            var _href = this.href,
                pathname = _href.pathname,
                hash = _href.hash,
                query = _href.query,
                protocol = _href.protocol;


            if (!activeClass || !activeMatch || protocol) return; // eslint-disable-line consistent-return

            var routerStore = this.getStatefromStore();
            var immutable = this.router.immutable;


            var isActive = true;

            if (activeMatch instanceof RegExp) {
                var routePath = immutable ? routerStore.get('path') : routerStore.path;

                return this.setState({ // eslint-disable-line consistent-return
                    isActive: activeMatch.test(routePath)
                });
            }

            if (activeMatch === _constants.LINK_MATCH_EXACT) {
                if (hash) {
                    var routeHash = immutable ? routerStore.get('hash') : routerStore.hash;
                    isActive = isActive && hash === routeHash;
                }

                if (query && Object.keys(query).length) {
                    var routeQuery = immutable ? routerStore.get('query').toJS() : routerStore.query;
                    isActive = isActive && Object.keys(query).reduce(function (result, item) {
                        return result && compareQueryItems(query[item], routeQuery[item]);
                    }, true);
                }
            }

            var routePathname = immutable ? routerStore.get('pathname') : routerStore.pathname;

            isActive = isActive && (activeMatch === _constants.LINK_MATCH_EXACT ? pathname === routePathname : routePathname.indexOf(pathname) === 0);

            if (isActive !== this.state.isActive) {
                this.setState({
                    isActive: isActive
                });
            }
        }
    }, {
        key: 'locationChange',
        value: function locationChange(_ref) {
            var pathname = _ref.pathname,
                query = _ref.query,
                search = _ref.search,
                hash = _ref.hash;
            var method = this.props.method;


            search = query || search;
            search = (typeof search === 'undefined' ? 'undefined' : _typeof(search)) === 'object' ? _queryString2.default.stringify(search) : search;

            this.store.dispatch(actions[method]({ pathname: pathname || '', search: search, hash: hash }));
        }
    }, {
        key: 'render',
        value: function render() {
            var _props2 = this.props,
                children = _props2.children,
                activeClass = _props2.activeClass,
                className = _props2.className,
                _props2$target = _props2.target,
                target = _props2$target === undefined ? null : _props2$target;

            var classes = this.state.isActive ? className + ' ' + activeClass : className;

            var props = _extends({}, this.props, {
                target: target,
                href: (0, _url.format)(this.href),
                className: classes
            });

            props.onClick = this.handleClick;

            return _react2.default.createElement('a', filterProps(props), children);
        }
    }]);

    return Link;
}(_Base2.default);

Link.contextTypes = {
    router: _propTypes2.default.object,
    store: _propTypes2.default.object
};

Link.defaultProps = {
    to: '',
    className: _constants.LINK_CLASSNAME,
    activeClass: _constants.LINK_ACTIVE_CLASSNAME,
    method: _constants.LINK_DEFAULT_METHOD,
    activeMatch: false
};

if (_constants.__DEV__) {
    Link.propTypes = {
        to: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.object]),
        className: _propTypes2.default.string,
        activeClass: _propTypes2.default.string,
        onClick: _propTypes2.default.oneOfType([_propTypes2.default.instanceOf(Function), _propTypes2.default.instanceOf(Promise)]),
        target: _propTypes2.default.string,
        method: _propTypes2.default.string,
        children: _propTypes2.default.any,
        activeMatch: function activeMatch(props, propName, componentName) {
            if (![false, _constants.LINK_MATCH_EXACT, _constants.LINK_MATCH_PARTIAL].includes(props[propName]) && !(props[propName] instanceof RegExp)) {
                return new Error('Invalid prop `' + propName + '` supplied to' + ' `' + componentName + '`. ' + ('Should be one of [false, \'' + _constants.LINK_MATCH_EXACT + '\', \'' + _constants.LINK_MATCH_PARTIAL + '\'] or an instance of RegExp'));
            }
        }
    };
}

exports.default = Link;