'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _routeToLocation = require('../parsers/routeToLocation');

var _routeToLocation2 = _interopRequireDefault(_routeToLocation);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Provider = function (_Component) {
    _inherits(Provider, _Component);

    function Provider() {
        _classCallCheck(this, Provider);

        return _possibleConstructorReturn(this, (Provider.__proto__ || Object.getPrototypeOf(Provider)).apply(this, arguments));
    }

    _createClass(Provider, [{
        key: 'getChildContext',
        value: function getChildContext() {
            var _props = this.props,
                immutable = _props.immutable,
                slice = _props.slice,
                routes = _props.routes,
                current = _props.current;

            var router = {
                immutable: immutable,
                slice: slice,
                routes: routes,
                parseRoute: (0, _routeToLocation2.default)(routes),
                current: current
            };

            return { router: router };
        }
    }, {
        key: 'render',
        value: function render() {
            return _react.Children.only(this.props.children);
        }
    }]);

    return Provider;
}(_react.Component);

Provider.childContextTypes = {
    router: _propTypes2.default.shape({
        slice: _propTypes2.default.string,
        immutable: _propTypes2.default.bool,
        routes: _propTypes2.default.array
    }).isRequired
};

Provider.defaultProps = {
    immutable: false,
    slice: _constants.DEFAULT_SLICE,
    routes: [],
    current: ''
};

if (_constants.__DEV__) {
    Provider.propTypes = {
        immutable: _propTypes2.default.bool.isRequired,
        slice: _propTypes2.default.string.isRequired,
        routes: _propTypes2.default.array.isRequired,
        current: _propTypes2.default.string.isRequired,
        children: _propTypes2.default.oneOfType([_propTypes2.default.element, _propTypes2.default.arrayOf(_propTypes2.default.element), _propTypes2.default.string])
    };
}

exports.default = Provider;